VIRTIO_MMIO(4)

NAME
virtio_mmio - VirtIO over memory mapped device

SYNOPSIS
pv* at pvbus?
virtio* at pv?

acpi0 at mainbus0
virtio* at acpi?

DESCRIPTION
virtio_mmio can be used in virtual environments without pci(4) support (a common situation in embedded devices models) might use simple memory mapped device (virtio_mmio) instead of the pci(4) device.

The memory mapped virtio(4) device behavior is based on the pci(4) device specification. Therefore most operations including device initialization, queues configuration and buffer transfers are nearly identical.

Unlike pci(4), virtio_mmio provides no generic device discovery mechanism. For each device, the guest OS will need to know the location of the registers and interrupt(s) used.

Device location can be read from either acpi(4) or via kernel command line parameters, implemented as a pv(4) virtual device.

SEE ALSO
virtio(4)

Virtual I/O Device (VIRTIO) Version 1.2, https://docs.oasis-open.org/virtio/virtio/v1.2/virtio-v1.2.html.